﻿using System;
using System.Windows.Forms;

namespace App
{
    public partial class DigitalKeyboardForm : Form
    {
        //首次点击
        bool isfirst = true;
        /// <summary>
        /// 输入数据最大值
        /// </summary>
        public int ExMaxValue { set; get; } = 1000;

        /// <summary>
        /// 输入数据最小值
        /// </summary>
        public int ExMinValue { set; get; } = 0;

        /// <summary>
        /// 当前值
        /// </summary>
        public int ExNowValue { set; get; } = 0;

        /// <summary>
        /// 返回值
        /// </summary>
        public bool ExResault { get; private set; } = false;

        public DigitalKeyboardForm()
        {
            InitializeComponent();
        }

        private void DigitalKeyboardForm_Load(object sender, EventArgs e)
        {
            this.KeyPreview = true;
            this.KeyDown += form_KeyDown;

            //显示当前值
            textBoxValue.Text = ExNowValue.ToString();
            labelMaxMin.Text = string.Format("最小值: {0}   最大值: {1}", ExMinValue, ExMaxValue);
        }

        private void form_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyData == Keys.Escape)
            {
                ExResault = false;
                this.Close();
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            SetNumber(1);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            SetNumber(2);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            SetNumber(3);
        }

        private void button4_Click(object sender, EventArgs e)
        {
            SetNumber(4);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            SetNumber(5);
        }

        private void button6_Click(object sender, EventArgs e)
        {
            SetNumber(6);
        }

        private void button7_Click(object sender, EventArgs e)
        {
            SetNumber(7);
        }

        private void button8_Click(object sender, EventArgs e)
        {
            SetNumber(8);
        }

        private void button9_Click(object sender, EventArgs e)
        {
            SetNumber(9);
        }

        private void button0_Click(object sender, EventArgs e)
        {
            SetNumber(0);
        }

        private void buttonBack_Click(object sender, EventArgs e)
        {
            if (ExNowValue == 0)
            {
                ExNowValue = 0;
            }
            else
            {
                ExNowValue = ExNowValue / 10;
            }
            textBoxValue.Text = ExNowValue.ToString();
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            if (ExNowValue > ExMaxValue)
            {
                MessageBox.Show(string.Format("输入值不能大于{0}", ExMaxValue));
                ExResault = false;
            }
            else
            if (ExNowValue < ExMinValue)
            {
                MessageBox.Show(string.Format("输入值不能小于{0}", ExMinValue));
                ExResault = false;
            }
            else
                this.Close();
        }


        private void SetNumber(int number)
        {
            //第一次点击，直接填当前按键值
            if (isfirst)
            {
                if (number > ExMaxValue)
                {
                    MessageBox.Show(string.Format("输入值不能大于{0}", ExMaxValue));
                    ExResault = false;
                    return;
                }
                else
                if (number < ExMinValue)
                {
                    MessageBox.Show(string.Format("输入值不能小于{0}", ExMinValue));
                    ExResault = false;
                    return;
                }
                else
                {
                    ExNowValue = number;
                    isfirst = false;
                }
            }
            else
            if (ExNowValue == 0)
            {
                if (number > ExMaxValue)
                {
                    MessageBox.Show(string.Format("输入值不能大于{0}", ExMaxValue));
                    ExResault = false;
                    return;
                }
                else
                if (number < ExMinValue)
                {
                    MessageBox.Show(string.Format("输入值不能小于{0}", ExMinValue));
                    ExResault = false;
                    return;
                }
                else
                    ExNowValue = number;
            }
            else
            {
                if ((ExNowValue * 10 + number) > ExMaxValue)
                {
                    MessageBox.Show(string.Format("输入值不能大于{0}", ExMaxValue));
                }
                else
                if ((ExNowValue * 10 + number) < ExMinValue)
                {
                    MessageBox.Show(string.Format("输入值不能小于{0}", ExMinValue));
                    ExResault = false;
                    return;
                }
                else
                    ExNowValue = ExNowValue * 10 + number;
            }
            textBoxValue.Text = ExNowValue.ToString();
            ExResault = true;
        }
    }
}
