﻿using RestSharp;
using System;
using System.Collections.Generic;

namespace WpfMap.Class
{
    public class IGK_Http
    {
        /// <summary>
        /// 发起一个HTTP请求（以GET方式）
        /// </summary>
        /// <param name="url">链接</param>
        /// <returns></returns>
        public static string HttpGet(string url)
        {
            try
            {
                var client = new RestClient(url);
                client.Timeout = 3000;
                var request = new RestRequest(Method.GET);
                string res = client.Execute(request).Content;
                client.ClearHandlers();
                return res;
            }
            catch (Exception ex)
            {
                return ex.Message.ToString();
            }

        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="url"></param>
        /// <param name="parameters"></param>
        /// <returns></returns>
        public static string HttpGet(string url,Dictionary<string, string> parameters)
        {
            try
            {
                url += "?";
                foreach (var item in parameters)
                {
                    url += item.Key + "=" + item.Value+"&";
                }
                var client = new RestClient(url);
                client.Timeout = 3000;
                var request = new RestRequest(Method.GET);
                string str = client.Execute(request).Content;
                client.ClearHandlers();
                return str;
            }
            catch (Exception ex)
            {
                return ex.Message.ToString();
            }

        }
        /// <summary>
        /// 发起一个Post请求
        /// </summary>
        /// <param name="url">链接</param>
        /// <param name="Name">参数名</param>
        /// <param name="Value">参数值</param>
        /// <returns></returns>
        public static string PostRequest(string url, string Name, string Value)
        {
            try
            {
                var request = new RestRequest("resource?auth_token={token}", Method.POST);
                var client = new RestClient(url);
                request.ReadWriteTimeout = 3000;
                client.Timeout = 3000;
                request = new RestRequest(Method.POST);
                request.AddParameter(Name, Value, ParameterType.QueryString);
                string res = client.Execute(request).Content;
                client.ClearHandlers();
                return res;
            }
            catch (Exception ex)
            {
                return ex.Message.ToString();
            }
        }
    }
}
