﻿using System.Collections.Generic;
using System.Management;
using System.Text.RegularExpressions;
using System.Threading;
using WpfMap.Class;

namespace App
{
    public class LocationClass
    {
        public static Root GetLocation()
        {
            Root loaction = new Root(); 
            //string res = IGK_Http.HttpGet("https://www.ipshudi.com/124.114.147.172.htm");
            string res = IGK_Http.HttpGet("https://api.live.bilibili.com/client/v1/Ip/getInfoNew");
            string[] strArray = Regex.Split(res, "\"", RegexOptions.IgnoreCase);
            loaction.data = new Data();
            loaction.data.country = strArray[19];
            loaction.data.province = strArray[23]; 
            loaction.data.city = strArray[27];
            return loaction;
        }

        //主板序列号
        public static string getMBSN()
        {
            //获取主板序列号
            string mbsn = "";
            try
            {
                ManagementClass mc = new ManagementClass("win32_baseboard");
                ManagementObjectCollection moc = mc.GetInstances();
                foreach (ManagementObject mo in moc)
                {
                    mbsn = mo.Properties["SerialNumber"].Value.ToString();
                    break;
                }
            }
            catch
            {
            }
            return mbsn;
        }
        public static void UploadThread(object obj)
        {
            try
            {
                string str = obj as string;
                Root loaction = GetLocation();
                if (loaction != null)
                {
                    //上传位置信息
                    string url = "http://mes.igeekiot.com/Api/public";
                    string DeviceSN = getMBSN();
                    Dictionary<string, string> parameters1 = new Dictionary<string, string>();
                    parameters1.Add("service", "App.GztRecord.Add");
                    parameters1.Add("registerCode", "0000000000000000");//注册码
                    parameters1.Add("isActived", "0");
                    parameters1.Add("location", loaction.Tostring());
                    parameters1.Add("cid", "000000");
                    parameters1.Add("type", "IGK-IAP");
                    parameters1.Add("msg", "用户名:" + System.Environment.UserName + "-主板序列号:" + DeviceSN + "-操作:" + str);
                    string res = IGK_Http.HttpGet(url, parameters1);
                }
            }
            catch
            {
            }
        }

        /// <summary>
        /// 上传信息到服务器
        /// </summary>
        public static void UploadRecord(string Operate)
        {
            Thread thread = new Thread(new ParameterizedThreadStart(UploadThread));
            thread.IsBackground = true;
            thread.Start(Operate);
        }
    }

    public class Data
    {
        /// <summary>
        /// 
        /// </summary>
        public string addr { get; set; }

        /// <summary>
        /// 中国
        /// </summary>
        public string country { get; set; }

        /// <summary>
        /// 陕西
        /// </summary>
        public string province { get; set; }

        /// <summary>
        /// 西安
        /// </summary>
        public string city { get; set; }

        /// <summary>
        /// 联通
        /// </summary>
        public string isp { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string latitude { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string longitude { get; set; }

    }



    public class Root
    {
        /// <summary>
        /// 
        /// </summary>
        public int code { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string msg { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string message { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public Data data { get; set; }

        public string Tostring()
        {
            return data.country + "-" + data.province + "-" + data.city;
        }

    }

}
